"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateNamespace = void 0;
const path = __importStar(require("path"));
const Guard = __importStar(require("../Guard"));
const Name = __importStar(require("../Name"));
const Reference = __importStar(require("./Reference"));
const RequestBody = __importStar(require("./RequestBody"));
const generateNamespace = (entryPoint, currentPoint, store, factory, requestBodies, context, converterContext) => {
    const basePath = "components/requestBodies";
    store.addComponent("requestBodies", {
        kind: "namespace",
        name: Name.Components.RequestBodies,
        comment: `@see https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.1.0.md#componentsObject`,
    });
    Object.entries(requestBodies).forEach(([name, requestBody]) => {
        if (Guard.isReference(requestBody)) {
            const reference = Reference.generate(entryPoint, currentPoint, requestBody);
            if (reference.type === "local") {
                throw new Error("not support");
            }
            else if (reference.type === "remote") {
                RequestBody.generateNamespace(entryPoint, reference.referencePoint, store, factory, path.dirname(reference.path), reference.name, reference.data, context, converterContext);
            }
        }
        else {
            RequestBody.generateNamespace(entryPoint, currentPoint, store, factory, basePath, name, requestBody, context, converterContext);
        }
    });
};
exports.generateNamespace = generateNamespace;
//# sourceMappingURL=RequestBodies.js.map