"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateNamespace = exports.generateInterface = void 0;
const MediaType = __importStar(require("./MediaType"));
const generateInterface = (entryPoint, currentPoint, factory, name, requestBody, context, converterContext) => {
    const contentSignatures = MediaType.generatePropertySignatures(entryPoint, currentPoint, factory, requestBody.content || {}, context, converterContext);
    return factory.InterfaceDeclaration.create({
        export: true,
        name,
        members: contentSignatures,
        comment: `@see https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.1.0.md#requestBodyObject`,
    });
};
exports.generateInterface = generateInterface;
const generateNamespace = (entryPoint, currentPoint, store, factory, parentName, name, requestBody, context, converterContext) => {
    const basePath = `${parentName}/${name}`;
    store.addStatement(basePath, {
        kind: "namespace",
        name,
        comment: requestBody.description,
    });
    store.addStatement(`${basePath}/Content`, {
        kind: "interface",
        name: "Content",
        value: exports.generateInterface(entryPoint, currentPoint, factory, "Content", requestBody, context, converterContext),
    });
};
exports.generateNamespace = generateNamespace;
//# sourceMappingURL=RequestBody.js.map