"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateStatements = void 0;
const PathItem = __importStar(require("../components/PathItem"));
const Reference = __importStar(require("../components/Reference"));
const Guard = __importStar(require("../Guard"));
const generateStatements = (entryPoint, currentPoint, store, factory, paths, context, converterContext) => {
    const statements = [];
    Object.entries(paths).forEach(([requestUri, pathItem]) => {
        if (!requestUri.startsWith("/")) {
            throw new Error(`Not start slash: ${requestUri}`);
        }
        if (Guard.isReference(pathItem)) {
            const reference = Reference.generate(entryPoint, currentPoint, pathItem);
            if (reference.type === "local") {
                statements.push(PathItem.generateStatements(entryPoint, currentPoint, store, factory, requestUri, store.getPathItem(reference.path), context, converterContext));
            }
            else {
                statements.push(PathItem.generateStatements(entryPoint, reference.referencePoint, store, factory, requestUri, reference.data, context, converterContext));
            }
        }
        else {
            statements.push(PathItem.generateStatements(entryPoint, currentPoint, store, factory, requestUri, pathItem, context, converterContext));
        }
    });
    store.addAdditionalStatement(statements.flat());
};
exports.generateStatements = generateStatements;
//# sourceMappingURL=index.js.map