import ts from "typescript";
import { DevelopmentError } from "../Exception";
import * as Factory from "./factory";
import { traverse } from "./traverse";
export { Factory };
export const convertAstToTypeScriptCode = (sourceFile) => {
    const printer = ts.createPrinter(); // AST -> TypeScriptに変換
    return printer.printFile(sourceFile);
};
export const generate = (createFunction) => {
    const source = ts.createSourceFile("", "", ts.ScriptTarget.ESNext);
    const transformers = [traverse(createFunction)];
    const result = ts.transform(source, transformers);
    result.dispose();
    if (result.transformed.length > 1) {
        throw new DevelopmentError("1個以上あるよ");
    }
    return convertAstToTypeScriptCode(result.transformed[0]);
};
//# sourceMappingURL=index.js.map