export const parameterName = (operationId) => `Parameter$${operationId}`;
export const requestBodyName = (operationId) => `RequestBody$${operationId}`;
export const argumentParamsTypeDeclaration = (operationId) => `Params$${operationId}`;
export const responseName = (operationId, statusCode) => `Response$${operationId}$Status$${statusCode}`;
export const requestContentType = (operationId) => `RequestContentType$${operationId}`;
export const responseContentType = (operationId) => `ResponseContentType$${operationId}`;
export const isAvailableVariableName = (text) => {
    return /^[A-Za-z_0-9\s]+$/.test(text);
};
export const escapeText = (text) => {
    if (isAvailableVariableName(text)) {
        return text;
    }
    return `"${text}"`;
};
export const Components = {
    Schemas: "Schemas",
    Parameters: "Parameters",
    Headers: "Headers",
    SecuritySchemas: "SecuritySchemas",
    PathItems: "PathItems",
    RequestBodies: "RequestBodies",
    Responses: "Responses",
};
export const ComponentChild = {
    Header: "Header",
    Content: "Content",
    Response: "Response",
};
//# sourceMappingURL=Name.js.map