import * as MediaType from "./MediaType";
export const generateInterface = (entryPoint, currentPoint, factory, name, requestBody, context, converterContext) => {
    const contentSignatures = MediaType.generatePropertySignatures(entryPoint, currentPoint, factory, requestBody.content || {}, context, converterContext);
    return factory.InterfaceDeclaration.create({
        export: true,
        name,
        members: contentSignatures,
        comment: `@see https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.1.0.md#requestBodyObject`,
    });
};
export const generateNamespace = (entryPoint, currentPoint, store, factory, parentName, name, requestBody, context, converterContext) => {
    const basePath = `${parentName}/${name}`;
    store.addStatement(basePath, {
        kind: "namespace",
        name,
        comment: requestBody.description,
    });
    store.addStatement(`${basePath}/Content`, {
        kind: "interface",
        name: "Content",
        value: generateInterface(entryPoint, currentPoint, factory, "Content", requestBody, context, converterContext),
    });
};
//# sourceMappingURL=RequestBody.js.map